[![Actions Status](https://github.com/wangronin/Bayesian-Optimization/workflows/Build%20and%20Test/badge.svg)](https://github.com/wangronin/Bayesian-Optimization/actions)

# Bayesian Optimization Library

A `Python` implementation of the Bayesian Optimization (BO) algorithm working on decision spaces composed of either real, integer, catergorical variables, or a mixture thereof.

Underpinned by surrogate models, BO iteratively proposes candidate solutions using the so-called **acquisition function** which balances exploration with exploitation, and updates the surrogate model with newly observed objective values. This algorithm is designed to optimize **expensive black-box** problems efficiently.

![](assets/BO-example.gif)

## Installation

You could either install the stable version on `pypi`:

```shell
pip install bayes-optim
```

Or, take the lastest version from github:

```shell
git clone https://github.com/wangronin/Bayesian-Optimization.git
cd Bayesian-Optimization && python setup.py install --user
```

## Example

For real-valued search variables, the simplest usage is via the `fmin` function:

```python
from bayes_optim import fmin

def f(x):
  return sum(x ** 2)

minimum = fmin(f, [-5] * 2, [5] * 2, max_FEs=30, seed=42)
```

And you could also have much finer control over most ingredients of BO, e.g., the surrogate
model and acquisition functions. Please see the example below:

```python
from bayes_optim import BO, ContinuousSpace
from bayes_optim.Surrogate import GaussianProcess

dim = 5
space = ContinuousSpace([-5, 5]) * dim  # create the search space

# hyperparameters of the GPR model
thetaL = 1e-10 * (ub - lb) * np.ones(dim)
thetaU = 10 * (ub - lb) * np.ones(dim)
model = GaussianProcess(                # create the GPR model
  thetaL=thetaL, thetaU=thetaU
)

opt = BO(
    search_space=space,
    obj_fun=fitness,
    model=model,
    DoE_size=5,                         # number of initial sample points
    max_FEs=50,                         # maximal function evaluation
    verbose=True
)
opt.run()
```

For more detailed usage and exmaples, please check out our [wiki page](https://github.com/wangronin/Bayesian-Optimization/wiki).

## Features

This implementation differs from alternative packages/libraries in the following features:

* **Parallelization**, also known as _batch-sequential optimization_, for which several different approaches are implemented here.
* **Moment-Generating Function of the improvment** (MGFI) [WvSEB17a] is a recently proposed acquistion function, which implictly controls the exploration-exploitation trade-off.
* **Mixed-Integer Evolution Strategy** for optimizing the acqusition function, which is enabled when the search space is a mixture of real, integer, and categorical variables.

## Project Structure

* `bayes-optim/SearchSpace.py`: implementation of the search/decision space.
* `bayes-optim/base.py`: the base class of Bayesian Optimization.
* `bayes-optim/AcquisitionFunction.py`: the implemetation of acquisition functions (see below for the list of implemented ones).
* `bayes-optim/Surrogate`: we implemented the Gaussian Process Regression (GPR) and Random Forest (RF).
* `bayes-optim/BayesOpt.py` contains several BO variants:
  * `BO`: noiseless + sequential
  * `ParallelBO`: noiseless + parallel (a.k.a. batch-sequential)
  * `AnnealingBO`: noiseless + parallel + annealling [WEB18]
  * `SelfAdaptiveBO`: noiseless + parallel + self-adaptive [WEB19]
  * `NoisyBO`: noisy + parallel
* `bayes-optim/Extension.py` is meant to include the lastest developments that are not extensively tested:
  * `PCABO`: noiseless + parallel + PCA-assisted dimensionality reduction [RaponiWBBD20] **[Under Construction]**
  * `MultiAcquisitionBO`: noiseless + parallelization with multiple different acquisition functions **[Under Construction]**

<!-- * `optimizer/`: the optimization algorithm to maximize the infill-criteria, two algorithms are implemented:
      1. **CMA-ES**: Covariance Martix Adaptation Evolution Strategy for _continuous_ optimization problems.
      2. **MIES**: Mixed-Integer Evolution Strategy for mixed-integer/categorical optimization problems. -->

## Acquisition Functions

The following infill-criteria are implemented in the library:

* _Expected Improvement_ (EI)
* Probability of Improvement (PI) / Probability of Improvement
* _Upper Confidence Bound_ (UCB)
* _Moment-Generating Function of Improvement_ (MGFI)
* _Generalized Expected Improvement_ (GEI) **[Under Construction]**

For sequential working mode, Expected Improvement is used by default. For parallelization mode, MGFI is enabled by default.

## Surrogate Model

The meta (surrogate)-model used in Bayesian optimization. The basic requirement for such a model is to provide the uncertainty quantification (either empirical or theorerical) for the prediction. To easily handle the categorical data, __random forest__ model is used by default. The implementation here is based the one in _scikit-learn_, with modifications on uncertainty quantification.

## A brief Introduction to Bayesian Optimization

Bayesian Optimization [Moc74, JSW98] (BO) is a sequential optimization strategy originally proposed to solve the single-objective black-box optimiza-tion problem that is costly to evaluate. Here, we shall restrict our discussion to the single-objective case. BO typically starts with sampling an initial design of experiment (DoE) of size, X={x<sub>1</sub>,x<sub>2</sub>,...,x<sub>n</sub>}, which is usually generated by simple random sampling, Latin Hypercube Sampling [SWN03], or the more sophisticated low-discrepancy sequence [Nie88] (e.g., Sobol sequences). Taking the initial DoE X and its corresponding objective value, Y={f(x<sub>1</sub>), f(x<sub>2</sub>),..., f(x<sub>n</sub>)} ⊆ ℝ, we proceed to construct a statistical model M describing the probability distribution of the objective function conditioned onthe initial evidence, namely Pr(f|X,Y). In most application scenarios of BO, there is a lack of a priori knowledge about f and therefore nonparametric models (e.g., Gaussian process regression or random forest) are commonly chosen for M, which gives rise to a predictor f'(x) for all x ∈ X and an uncertainty quantification s'(x) that estimates, for instance, the mean squared error of the predic-tion E(f'(x)−f(x))<sup>2</sup>. Based on f' and s', promising points can be identified via the so-called acquisition function which balances exploitation with exploration of the optimization process.

<!-- Bayesian optimization is __sequential design strategy__ that does not require the derivatives of the objective function and is designed to solve expensive global optimization problems. Compared to alternative optimization algorithms (or other design of experiment methods), the very distinctive feature of this method is the usage of a __posterior distribution__ over the (partially) unknown objective function, which is obtained via __Bayesian inference__. This optimization framework is proposed by Jonas Mockus and Antanas Zilinskas, et al.

Formally, the goal is to approach the global optimum, using a sequence of variables:
$$\mathbf{x}_1,\mathbf{x}_2, \ldots, \mathbf{x}_n \in S \subseteq \mathbb{R}^d,$$
which resembles the search sequence in stochastic hill-climbing, simulated annealing and (1+1)-strategies. The only difference is that such a sequence is __not__ necessarily random and it is actually deterministic (in principle) for Bayesian optimization. In order to approach the global optimum, this algorithm iteratively seeks for an optimal choice as the next candidate variable adn the choice can be considered as a decision function:
\[\mathbf{x}_{n+1} = d_n\left(\{\mathbf{x}_i\}_{i=1}^n, \{y_i\}_{i=1}^n \right), \quad y_i = f(\mathbf{x}_i) + \varepsilon,\]
meaning that it takes the history of the optimization in order to make a decision. The quality of a decision can be measured by the following loss function that is the optimality error or optimality gap:
$$\epsilon(f, d_n) = f(\mathbf{x}_n) - f(\mathbf{x}^*),\quad \text{in the objective space,}$$
or
$$\epsilon(f, d_n) = ||\mathbf{x}_n - \mathbf{x}^*||,\quad \text{in the decision space,}$$
Using this error measure, the step-wise optimization task can be formulated as:
$$d_n^* = \operatorname{arg\,min}_{d_n}\epsilon(f, d_n)$$
This optimization task requires the full knowledge on the objective function $f$, which is not available (of course...). Alternatively, in Bayesian optimization, it is assumed that the objective function belongs to a function family or _function space_, e.g. $\mathcal{C}^1(\mathbb{R}^d):$ the space of continuous functions on $\mathbb{R}^d$ that have continuous first-order derivatives.

Without loss of generality, let's assume our objective function is in such a function space:
$$f\in \mathcal{C}^1\left(\mathbb{R}^d\right)$$
Then, it is possible to pose a prior distribution of _function_ $f$ in $\mathcal{C}^1\left(\mathbb{R}^d\right)$ (given that this space is also measurable):
$$f \sim P(f)$$
This prior distribution models our belief on $f$ before observing any data samples from it. The likelihood can be obtained by observing (noisy) samples on this function $f$, which is the  joint probability (density) of observing the data set given the function $f$:
$$P(\{\mathbf{x}_i\}_{i=1}^n, \{y_i\}_{i=1}^n | f)$$ 
Then, using the Bayes rule, the __posterior__ distribution of $f$ is calculated as:
$$\underbrace{P(f | \{\mathbf{x}_i\}_{i=1}^n, \{y_i\}_{i=1}^n)}_{\text{posterior}} \propto \underbrace{P(\{\mathbf{x}_i\}_{i=1}^n, \{y_i\}_{i=1}^n | f)}_{\text{likelihood/evidence}}\underbrace{P(f)}_{\text{prior}}$$
Intuitively, the posterior tells us that how the function $f$ distributes once some data/evidence from it are available. At this point, our knowledge on $f$ is better than nothing, but it is represented as a distribution, containing uncertainties. Therefore, the optimal decision-making task can be tackled by optimizing the expected loss function:
$$
d_n^{BO} = \operatorname{arg\,min}_{d_n}\mathbb{E}\left[\epsilon(f, d_n) \; |\; \{\mathbf{x}_i\}_{i=1}^n, \{y_i\}_{i=1}^n)\right]\\
\quad\quad\quad\;\:= \operatorname{arg\,min}_{d_n}\int_{\mathcal{C}^1\left(\mathbb{R}^d\right)}\epsilon(f, d_n) \mathrm{d} P(f | \{\mathbf{x}_i\}_{i=1}^n, \{y_i\}_{i=1}^n)
$$
In practice, the loss function $\epsilon$ is not used because there is not knowledge on the global optimum of $f$. Instead, the improvement between two iterations/steps (as defined in section $1$) is commonly used. The expectation in Eq.~\ref{eq:infill} is the so-called __infill-criteria__, __acquisition function__ or __selection criteria__. Some commonly used ones are: Expected Improvement (EI), Probability of Improvement (PI) and Upper (lower) Confidence Bound (UCB).

As for the prior distribution, the mostly used one is Gaussian and such a distribution on functions is __Gaussian process__ (random field). It is also possible to consider the Gaussian process as a _surrogate_ or simple a model on the unknown function $f$. In this sense, some other models are also often exploited, e.g. Student's t process and random forest (in SMAC and SPOT). However, the usage of random forest models brings me some additional thinkings (see the following sections).

The same algorithmic idea was re-advertised in the name of "Efficient Global Optimization"" (EGO) by Donald R. Jones. As pointed out in Jone's paper on taxonomy of global optimization methods, the bayesian optimization can be viewed as a special case of a broader family of similar algorithms, that is call "global optimization based on response surfaces", Model-based Optimization (MBO) (some references here from Bernd Bischl) or Sequential MBO. -->

## Reference

* [Moc74] Jonas Mockus. "On bayesian methods for seeking the extremum". In Guri I. Marchuk, editor, _Optimization Techniques, IFIP Technical Conference, Novosibirsk_, USSR, July 1-7, 1974, volume 27 of _Lecture Notes in Computer Science_, pages 400–404. Springer, 1974.
* [JSW98] Donald R. Jones, Matthias Schonlau, and William J. Welch. "Efficient global optimization of expensive black-box functions". _J. Glob. Optim._, 13(4):455–492, 1998.
* [SWN03] Thomas J. Santner, Brian J. Williams, and William I. Notz. "The Design and Analysis of Computer Experiments". _Springer series in statistics._ Springer, 2003.
* [Nie88] Harald Niederreiter. "Low-discrepancy and low-dispersion sequences". _Journal of number theory_, 30(1):51–70, 1988.
* [WvSEB17a] Hao Wang, Bas van Stein, Michael Emmerich, and Thomas Bäck. "A New Acquisition Function for Bayesian Optimization Based on the Moment-Generating Function". In _Systems, Man, and Cybernetics (SMC), 2017 IEEE International Conference on_, pages 507–512. IEEE, 2017.
* [WEB18] Hao Wang, Michael Emmerich, and Thomas Bäck. "Cooling Strategies for the Moment-Generating Function in Bayesian Global Optimization". In _2018 IEEE Congress on Evolutionary Computation_, CEC 2018, Rio de Janeiro, Brazil, July 8-13, 2018, pages 1–8. IEEE, 2018.
* [WEB19] Hao, Wang, Michael Emmerich, and Thomas Bäck. "Towards self-adaptive efficient global optimization". In _AIP Conference Proceedings_, vol. 2070, no. 1, p. 020056. AIP Publishing LLC, 2019.
* [RaponiWBBD20] Elena Raponi, Hao Wang, Mariusz Bujny, Simonetta Boria, and Carola Doerr: "High Dimensional Bayesian Optimization Assisted by Principal Component Analysis". In _International Conference on Parallel Problem Solving from Nature_, pp. 169-183. Springer, Cham, 2020.

# NOTE: to trigger re-rendering of `job_table`
trigger_update_job_table <- reactiveVal()

search_space <- reactive({
  req(input$upload.add_zip$datapath)
  json_data <- jsonlite::read_json(input$upload.add_zip$datapath)
})

session$onRestore(
  function() {
    trigger_update_job_table(rnorm(1))
  }
)

# table of current job information
job_table <- eventReactive(
  trigger_update_job_table(), {
    r <- GET(
      address,
      query = list(check_job = 'null')
    )
    as.data.frame(do.call(rbind, content(r)))
  }
)

# create a job
observeEvent(input$upload.create_job, {
  .cs <- search_space()

  if (length(.cs) != 0) {
    r <- POST(address, body = .cs, encode = 'json')
    if (status_code(r) == 200) {
      job_id <- content(r)$job_id
      trigger_update_job_table(rnorm(1))

      print_html(
        paste0(
          '<p style="color:red;">成功创建',
          job_id,
          '任务!</p>'
        )
      )
    } else if (status_code(r) == 500) {
      print_html(
        paste0(
          '<p style="color:red;">任务创建失败:',
          content(r)$error,
          '</p>'
        )
      )
    }
  }
})

# delete a job
observeEvent(input$upload.delete_job, {
  req(input$job_list_delete)
  job_id <- input$job_list_delete

  r <- GET(
    address,
    query = list(finalize = 'null', job_id = job_id)
  )

  if (status_code(r) == 200) {
    print_html(
      paste0(
        '<p style="color:red;">成功删除',
        job_id,
        '任务!</p>'
      )
    )
  } else if (status_code(r) == 500) {
    print_html(
      paste0(
        '<p style="color:red;">删除任务失败:',
        content(r)$error,
        '</p>'
      )
    )
  }
  trigger_update_job_table(rnorm(1))
})

# update all control widgets depending on `job_table`
observe({
  req(job_table())
  .list <- rownames(job_table())

  if (length(.list) == 0)
    .selected <- NULL
  else
    .selected <- .list[1]

  updateSelectInput(session, 'job_list_delete', choices = .list, selected = .selected)
  updateSelectInput(session, 'ask_tell_box.job_id', choices = .list, selected = .selected)
  updateSelectInput(session, 'feature_importance_box.job_id', choices = .list, selected = .selected)
})

# handle the download request to the job table
output$data_info <- renderDataTable({
  job_table()
}, options = list(
  pageLength = 10, scrollX = F, autoWidth = TRUE,
  columnDefs = list(list(width = '20px', targets = c(0, 1))))
)

# handle the download request to the example JSON file
output$upload_box.download <- downloadHandler(
  filename = function() {
    'example.json'
  },
  content = function(.file) {
    data <- toJSON(
      read_json('example_continuous.json'),
      pretty = TRUE, auto_unbox = TRUE
    )
    con <- file(.file)
    writeLines(data, con)
    close (con)
  }
)

# TODO: reactiveValues is not necessary here; a global var. should suffice
tell_lock <- reactiveValues(value = NULL) # to ensure the last `tell` request is finished

# NOTE: `dataTableProxy` is used to update a `DT` table partly without regenerating the full table
proxy <- dataTableProxy('ask_tell_box.data_table')
# TODO: reactiveVal might not be necessary here..
data_table <- reactiveVal(NULL)
# NOTE: to trigger re-rendering of `data_table`, which is needed since we do not trigger
# re-rendering the table when the user is editing the table
trigger_renderDT <- reactiveVal(NULL)

# TODO: add the progress bar to the ask/tell request
# send the `ask` request
observeEvent(input$ask_tell_box.ask, {
  job_id <- input$ask_tell_box.job_id
  shinyjs::disable('ask_tell_box.ask')
  shinyjs::disable('ask_tell_box.tell')

  r <- GET(
    address,
    query = list(ask = 'null', job_id = job_id)
  )

  if (status_code(r) == 200) {
    dt <- as.data.table(do.call(rbind, content(r)['X'][[1]]))
    dt$y <- 0
    data_table(dt)
    trigger_renderDT(rnorm(1))

    print_html2(
      paste0(
        '<p style="color:red;">任务',
        job_id,
        '获取一组解成功！</p>'
      )
    )
  } else if (status_code(r) == 500) {
    print_html2(
      paste0(
        '<p style="color:red;">获取一组解失败:',
        content(r)$error,
        '</p>'
      )
    )
  }
  shinyjs::enable('ask_tell_box.ask')
  shinyjs::enable('ask_tell_box.tell')
})

# send the `tell` request
observeEvent(input$ask_tell_box.tell, {
  job_id <- input$ask_tell_box.job_id
  shinyjs::disable('ask_tell_box.ask')
  shinyjs::disable('ask_tell_box.tell')

  # hold the tell lock
  tell_lock$value <- 1

  dt <- data_table()
  X <- dt[, -c('y')]
  y <- dt$y
  json_data <- jsonlite::toJSON(list(X = X, y = y, job_id = job_id), auto_unbox = T)

  r <- POST(
    address,
    body = json_data, encode = 'json'
  )

  if (status_code(r) == 200) {
    print_html2(
      paste(
        '<p style="color:red;">成功添加目标值',
        paste(y, collapse = ', '),
        '至任务',
        job_id,
        '</p>'
      )
    )
  } else if (status_code(r) == 500) {
    print_html2(
      paste0(
        '<p style="color:red;">添加目标值失败!',
        content(r)$error,
        '</p>'
      )
    )
  }
  # hold the tell lock
  tell_lock$value <- 0
  shinyjs::enable('ask_tell_box.ask')
  shinyjs::enable('ask_tell_box.tell')
})

# add a json file containing the tell data
observeEvent(input$ask_tell_box.add_json, {
  path <- input$ask_tell_box.add_json$datapath
  req(path)

  json_data <- jsonlite::read_json(path)
  df <- as.data.table(do.call(rbind, json_data['X'][[1]]))
  df$y <- json_data$y

  if (is.null(data_table())) {
    data_table(df)
    trigger_renderDT(rnorm(1))
  } else if (ncol(df) == ncol(data_table())) {
    data_table(df)
    replaceData(
      proxy, data_table(),
      resetPaging = FALSE,
      rownames = FALSE
    )
  } else {
    data_table(df)
    trigger_renderDT(rnorm(1))
  }
})

# handle users' editing events on the table cells
observeEvent(input$ask_tell_box.data_table_cell_edit, {
  info <- input$ask_tell_box.data_table_cell_edit
  i <- info$row
  j <- info$col + 1
  v <- info$value

  suppressWarnings({
    dt <- data_table()
    set(dt, i, j, as.numeric(v))
    data_table(dt)
  })

  replaceData(
    proxy, data_table(),
    resetPaging = FALSE, rownames = FALSE
  )
})

# TODO: test the appearence of the table when the dimensionality is high
# (re-)rendering of the data table
output$ask_tell_box.data_table <- DT::renderDataTable({
    trigger_renderDT()
    isolate({data_table()})
  },
  editable = TRUE,
  rownames = F,
  options = list(
    pageLength = 10,
    scrollX = T,
    autoWidth = TRUE,
    columnDefs = list(
      list(
        className = 'dt-right', targets = "_all"
      )
    )
  )
)

# handle the download request of the data table
output$ask_tell_box.download <- downloadHandler(
  filename = function() {
    'solutions.json'
  },
  content = function(file) {
    dt <- data_table()
    X <- dt[, -c('y')]
    y <- dt$y
    jsonlite::write_json(list(X = X, y = y), file, auto_unbox = T)
  }
)

for (f in list.files('ui', pattern = '.R', full.names = T)) {
  source(f)
}

header <- dashboardHeader(title = HTML('<div align="center"><b>AI Excelsior</b></div>'))

# The side bar layout ---------------------------------------------
sidebar <- dashboardSidebar(
  useShinyjs(),
  sidebar_menu()
)

body <- dashboardBody(
  tags$style(
    HTML('
       .popover-title {color:black;}
       .popover-content {color:black;}
       .main-sidebar {z-index:auto;}
       .fa-exclamation-triangle {color:#E87722}
       .sticky {
         position: fixed;
         top: 0;
         width: 100%;
       }

       .sticky2 {
         position: fixed;
       }

       .table {
          border-collapse: collapse;
          width: 100%;
        }
       .table td, tr {
          padding: 0px;
          margin: 0px;
          vertical-align: middle;
          height: 45px;
        }
       .table th {height: 0px;}'
    )
  ),

  # to show text on the header (heading banner)
  tags$head(
    tags$style(
      HTML('
        .myClass {
          font-size: 20px;
          line-height: 50px;
          text-align: left;
          font-family: "Helvetica Neue",Helvetica,Arial,sans-serif;
          padding: 0 15px;
          overflow: hidden;
          color: white;
        }'
      )
    )
  ),

  tags$head(
    tags$style(
      HTML(
        '.box-title {
            font-size: 20px;
            line-height: 50px;
            text-align: left;
            font-family: "Helvetica Neue",Helvetica,Arial,sans-serif;
            padding: 0 15px;
            overflow: hidden;
            color: white;
          }'
      )
    )
  ),

  tags$head(
    tags$style(
      HTML(
        "label { font-size:120%; }"
      )
    )
  ),

  tags$script(
    HTML('
      $(document).ready(function() {
        $("header").find("nav").append(\'<span class="myClass">Performance Evaluation for Iterative
        Optimization Heuristics</span>\');
      })
   ')
  ),

  tags$script(
    "Shiny.addCustomMessageHandler('background-color',
      function(color) {
        document.body.style.backgroundColor = color;
        document.body.innerText = color;
      });"
  ),

  tags$script(
    HTML('
      window.setInterval(function() {
        var elem = document.getElementById("process_data_promt");
        if (typeof elem !== "undefined" && elem !== null) elem.scrollTop = elem.scrollHeight;
      }, 20);'
    )
  ),

  tags$head(
    tags$script(
      HTML("
        Shiny.addCustomMessageHandler('manipulateMenuItem', function(message){
          var aNodeList = document.getElementsByTagName('a');

          for (var i = 0; i < aNodeList.length; i++) {
            if(aNodeList[i].getAttribute('data-value') == message.tabName || aNodeList[i].getAttribute('href') == message.tabName) {
              if(message.action == 'hide'){
                aNodeList[i].setAttribute('style', 'display: none;');
              } else {
                aNodeList[i].setAttribute('style', 'display: block;');
              };
            };
          }
        });
      ")
    )
  ),

  # make the data uploading prompt always scroll to the bottom
  tags$script(
    HTML('
       window.setInterval(function() {
         var elem = document.getElementById("upload_data_promt");
         if (typeof elem !== "undefined" && elem !== null) elem.scrollTop = elem.scrollHeight;
       }, 20);
    ')
  ),

  # render the header and the side bar 'sticky'
  tags$script(
    HTML(
      '// When the user scrolls the page, execute myFunction
      window.onscroll = function() {myFunction()};

      // Get the header
      var header = document.getElementById("header");

      // Get the side bar
      var sideBar = document.getElementById("sidebarCollapsed");
      sideBar.classList.add("sticky2");

      // Get the offset position of the navbar
      var sticky = header.offsetTop;

      // Add the sticky class to the header when you reach its scroll position.
      // Remove "sticky" when you leave the scroll position
      function myFunction() {
        if (window.pageYOffset > sticky) {
          header.classList.add("sticky");
        } else {
          header.classList.remove("sticky");
        }
      }'
    )
  ),

  # load MathJax
  # TODO: download MathJax and its license and include it in our package
  HTML("<head><script src='https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.4/MathJax.js?config=TeX-MML-AM_CHTML'
       async></script></head>"),
  # use_bs_tooltip(),
  # use_bs_popover(),

  tabItems(
    tabItem(
      tabName = 'upload',
      fluidRow(
        column(
          width = 6,
          upload_box(collapsible = F)
        ),

        column(
          width = 6,
          job_list_box(collapsible = F)
        )
      ),

      fluidRow(
        column(
          width = 6,
          upload_prompt_box(collapsible = F)
        )
      )
    ),

    tabItem(
      tabName = 'execute_job_panel',
      fluidRow(
        column(
          width = 12,
          ask_tell_box(collapsible = F)
        )
      ),

      fluidRow(
        column(
          width = 6,
          progress_box(collapsible = F)
        ),
        column(
          width = 6,
          feature_importance_box(collapsible = F)
        )
      )
    ),

    tabItem(tabName = 'documentation', includeMarkdown('USAGE.md'))
  )
)

# -----------------------------------------------------------
dashboardPage(title = 'AIxcelsior', header, sidebar, body)

sidebar_menu <- function() {
  sidebarMenu(
    id = "tabs",
    menuItem(
      "创建任务", tabName = "upload",
      icon = icon('upload', lib = 'glyphicon'), selected = T
    ),
    menuItem(
      "优化任务面板", tabName = "execute_job_panel", icon = icon("line-chart")
    ),
    menuItem(
      "说明文档", tabName = "documentation", icon = icon("line-chart")
    )
  )
}

suppressMessages(library(shiny))
suppressMessages(library(shinyjs))
suppressMessages(library(magrittr))
suppressMessages(library(data.table))
suppressMessages(library(plotly))
suppressMessages(library(shinydashboard))
suppressMessages(library(DT))
suppressMessages(library(httr))
suppressMessages(library(jsonlite))

ip <- "106.14.217.207"
# ip <- '127.0.0.1'
port <- 7200
address <- paste0('http://', ip, ':', port)

HTML_P <- function(s) HTML(paste0('<p align="left" style="font-size:120%;">', s, '</p>'))

f1 <- function(size = 16) {
  list(
    size = size,
    family = 'Old Standard TT, serif'
  )
}

f2 <- function(size = 12) {
  list(
    family = 'Old Standard TT, serif',
    size = size,
    color = 'black'
  )
}

legend_below <- list(
  y = -0.2,
  orientation = 'h',
  font = f1()
)

.axis.style <- list(
  showgrid = TRUE,
  showline = FALSE,
  showticklabels = TRUE,
  ticks = 'outside',
  ticklen = 9,
  tickfont = f2(),
  exponentformat = 'e',
  zeroline = F
)

color_palettes <- function(ncolor) {
  brewer <- function(n) {
    colors <- RColorBrewer::brewer.pal(n, 'Spectral')
    colors[colors == "#FFFFBF"] <- "#B2B285"
    colors[colors == "#E6F598"] <- "#86FF33"
    colors[colors == '#FEE08B'] <- "#FFFF33"
    colors
  }

  color_fcts <- c(colorRamps::primary.colors)

  n <- min(11, ncolor)
  colors <- brewer(n)
  ncolor <- ncolor - n

  i <- 1
  while (ncolor > 0) {
    n <- min(8, ncolor)
    if (i > length(color_fcts)) {
      colors <- c(colors, colorRamps::primary.colors(ncolor))
      break
    } else {
      colors <- c(colors, color_fcts[[i]](n))
      ncolor <- ncolor - n
    }
    i <- i + 1
  }
  colors
}

.colors <- color_palettes(8)

plotly_default <- function(title = NULL, x.title = NULL, y.title = NULL) {
  plot_ly() %>%
    layout(
      title = list(text = title, font = f1()),
      autosize = T,
      hovermode = 'compare',
      legend = legend_below,
      paper_bgcolor = 'rgb(255,255,255)',
      font = f1(),
      autosize = T,
      showlegend = T,
      xaxis = c(list(title = x.title), .axis.style),
      yaxis = c(list(title = y.title), .axis.style)
    )
}

# global options
options(datatable.print.nrows = 20)
options(width = 80)
options(shiny.maxRequestSize = 200 * 1024 ^ 2)  # maximal upload file size

widget_html <- function(name, package, id, style, class, inline = FALSE, ...) {
  # attempt to lookup custom html function for widget
  fn <- tryCatch(get(paste0(name, "_html"),
                     asNamespace(package),
                     inherits = FALSE),
                 error = function(e) NULL)

  # call the custom function if we have one, otherwise create a div
  if (is.function(fn)) {
    fn(id = id, style = style, class = class, ...)
  } else if (inline) {
    tags$span(id = id, style = style, class = class)
  } else {
    tags$div(id = id, style = style, class = class)
  }
}

checkShinyVersion <- function(error = TRUE) {
  x <- utils::packageDescription('htmlwidgets', fields = 'Enhances')
  r <- '^.*?shiny \\(>= ([0-9.]+)\\).*$'
  if (is.na(x) || length(grep(r, x)) == 0 || system.file(package = 'shiny') == '')
    return()
  v <- gsub(r, '\\1', x)
  f <- if (error) stop else packageStartupMessage
  if (utils::packageVersion('shiny') < v)
    f("Please upgrade the 'shiny' package to (at least) version ", v)
}

widget_dependencies <- function(name, package){
  htmlwidgets::getDependency(name, package)
}

.plotlyOutput <- function(outputId, width = '100%', aspect_ratio = 16/10) {
  padding_bottom <- paste0(100 / aspect_ratio, '%')
  reportSize <- TRUE
  inline <- FALSE

  checkShinyVersion()
  html <- htmltools::tagList(
    widget_html('plotly', 'plotly', id = outputId,
                class = paste0('plotly', " html-widget html-widget-output",
                               if (reportSize)
                                 " shiny-report-size"),
                style = sprintf("width:%s; height: 0; padding-bottom:%s; %s",
                                htmltools::validateCssUnit(width),
                                htmltools::validateCssUnit(padding_bottom),
                                if (inline)
                                  "display: inline-block;"
                                else ""),
                width = width, height = 0)
  )
  dependencies <- widget_dependencies('plotly', 'plotly')
  htmltools::attachDependencies(html, dependencies)
}

print_html <- function(s, widget_id = 'process_data_promt')
  shinyjs::html(widget_id, s, add = TRUE)

print_html2 <- function(s, widget_id = 'tell_data_promt')
  shinyjs::html(widget_id, s, add = TRUE)

shinyServer(function(input, output, session) {
  session$onSessionEnded(
    # nothing to do for now..
    function() {}
  )
  
  for (f in list.files('server', pattern = '.R', full.names = T)) {
    source(f, local = TRUE)
  }
  
  # to trigger preparing the initial job table
  trigger_update_job_table(rnorm(1))
})

upload_box <- function(width = 12, collapsible = T, collapsed = T,
                       height = '400px') {
  box(
    title = HTML('<p style="font-size:120%;">创建优化任务</p>'),
    width = width, height = height, collapsed = collapsed, collapsible = collapsible,
    solidHeader = T, status = "primary",
    sidebarPanel(
      width = 12,
      
      downloadButton("upload_box.download", "下载JSON配置文件模板"),
      hr(),
      
      fileInput(
        "upload.add_zip",
        label = HTML(
          '<p align="left">
           请上传一个<i>JSON配置文件</i>来创建优化实例</p>'
        ),
        multiple = FALSE, accept = c("Application/json", ".json")
      ),

      actionButton(
        'upload.create_job',
        label = HTML(
          '<p align="center" style="margin-bottom:0;"><b>生成优化任务实例</b></p>'
        )
      )
    )
  )
}

upload_prompt_box <- function(width = 12, collapsible = T, collapsed = T) {
  box(
    title = HTML('<p style="font-size:120%;">Data Processing Prompt</p>'),
    width = width, solidHeader = T, status = "primary",
    collapsible = collapsible, collapsed = collapsed,

    verbatimTextOutput('process_data_promt'),
    tags$head(
      tags$style(
        "#process_data_promt{
           color:black; font-size:12px; font-style:italic;
           max-height: 500px;
           overflow-y:visible; overflow-x: auto;
           white-space: pre-wrap;
           white-space: -moz-pre-wrap;
           white-space: -pre-wrap;
           white-space: -o-pre-wrap;
           word-wrap: normal;
           background: ghostwhite;
        }"
      )
    )
  )
}

job_list_box <- function(width = 12, collapsible = T, collapsed = T) {
  box(
    title = HTML('<p style="font-size:120%;">当前活跃任务</p>'),
    width = width, solidHeader = T, status = "primary",
    collapsible = collapsible, collapsed = collapsed,
    dataTableOutput('data_info'),

    selectInput(
      'job_list_delete', label = "请在如下列表中选择要删除的任务",
      choices = NULL, selected = NULL, width = '50%'
    ),
    actionButton(
      'upload.delete_job',
      label = HTML(
        '<p align="center" style="margin-bottom:0;"><b>删除优化任务实例</b></p>'
      )
    )
  )
}

ask_tell_box <- function(width = 12, collapsible = T, collapsed = T) {
  box(
    title = HTML('<p style="font-size:120%;">Ask-Tell接口</p>'),
    width = width, solidHeader = T, status = "primary",
    collapsible = collapsible, collapsed = collapsed,
    
    fluidRow(
      column( 
        width = 4, align = "left", offset = 0, 
        style = 'padding-left:15px; padding-right:15px; padding-top:5px; padding-bottom:5px',
        selectInput(
          'ask_tell_box.job_id', label = "请在如下列表中选择任务ID",
          choices = NULL, selected = NULL, width = '50%'
        ),
        actionButton(
          'ask_tell_box.ask',
          label = HTML(
            '<p align="center" style="margin-bottom:0;"><b>获取一组解/Ask</b></p>'
          )
        )
      ),
      
      column(
        width = 8, align = "left", offset = 0, 
        style = 'padding-left:15px; padding-right:15px; padding-top:5px; padding-bottom:5px',
        verbatimTextOutput('tell_data_promt'),
        tags$head(
          tags$style(
            "#tell_data_promt{
               color:black; font-size:12px; font-style:italic;
               max-height: 130px;
               overflow-y:visible; overflow-x: auto;
               white-space: pre-wrap;
               white-space: -moz-pre-wrap;
               white-space: -pre-wrap;
               white-space: -o-pre-wrap;
               word-wrap: normal;
               background: ghostwhite;
             }"
          )
        )
      )
    ),
    
    hr(),
    br(),
    
    fluidRow(
      column(
        width = 8, align = "center",
        HTML_P(
          '您可以直接编辑如下的表格来添加目标值，
           并在结束添加之后点击“发送目标任务值”按钮来向服务器告知所添加的目标值'
        ),
        DT::dataTableOutput('ask_tell_box.data_table')
      ),
      
      column(
        width = 4, align = "left",
        actionButton(
          'ask_tell_box.tell',
          label = HTML(
            '<p align="center" style="margin-bottom:0;"><b>发送目标任务值/Tell</b></p>'
          )
        ),
        
        hr(),
        HTML_P('您也可以下载这组解(JSON格式)，并向其中加入一个名为`y`的字段来包含目标值。
           在您完成编辑后，可以直接上传这个JSON文件，之后上面的数据表格会自动更新。'),
        downloadButton("ask_tell_box.download", "您也可以下载这组解"),
        
        br(),
        br(),
        br(),
        
        fileInput(
          "ask_tell_box.add_json",
          label = HTML('<p align="left">上传编辑后的<i>JSON</i>文件</p>'),
          multiple = FALSE, accept = c("Application/json", ".json")
        )
      )
    )
  )
}

tell_box <- function(width = 12, collapsible = T, collapsed = T) {
  box(
    title = HTML('<p style="font-size:120%;">向服务器返回目标值</p>'),
    width = width, solidHeader = T, status = "primary",
    collapsible = collapsible, collapsed = collapsed,

    verbatimTextOutput('tell_data_promt'),
    tags$head(
      tags$style(
        "#tell_data_promt{
             color:black; font-size:12px; font-style:italic;
             max-height: 500px;
             overflow-y:visible; overflow-x: auto;
             white-space: pre-wrap;
             white-space: -moz-pre-wrap;
             white-space: -pre-wrap;
             white-space: -o-pre-wrap;
             word-wrap: normal;
             background: ghostwhite;
          }"
      )
    )
  )
}

progress_box <- function(width = 12, collapsible = T, collapsed = T) {
  box(
    title = HTML('<p style="font-size:120%;">任务进度</p>'),
    width = width, collapsible = collapsible, solidHeader = T,
    status = "primary", collapsed = collapsed,
    column(
      width = 12,
      align = "center",
      .plotlyOutput('progress_box.line_chart')
    )
  )
}

feature_importance_box <- function(width = 12, collapsible = T, collapsed = T) {
  box(
    title = HTML('<p style="font-size:120%;">参数重要性</p>'),
    width = width, collapsible = collapsible, solidHeader = T,
    status = "primary", collapsed = collapsed,
    selectInput(
      'feature_importance_box.job_id', label = "请在如下列表中选择任务ID",
      choices = NULL, selected = NULL, width = '50%'
    ),
    .plotlyOutput('feature_importance_box.bar_chart')
  )
}

output$feature_importance_box.bar_chart <- renderPlotly({
  data <- imp_data()
  p <- plotly_default('', '参数', '参数重要性')
  if (is.null(data)) return(p)

  i <- 1
  for (job_id in names(data)) {
    x <- unlist(data[[job_id]][['feature']])
    y <- unlist(data[[job_id]][['imp']])
    if (length(x) == 0) next()

    p <- add_trace(
      p, x = x, y = y, color = .colors[i %% 5], name = job_id,
      type = 'bar'
    )
    i <- i + 1
  }
  p
})

imp_data <- reactive({
  req(tell_lock$value)
  req(tell_lock$value == 0)
  job_id <- input$feature_importance_box.job_id
  .json <- list(
    get_feature_importance = as.list(job_id)
  )
  r <- POST(address, body = .json, encode = 'json')
  content(r)
})

output$progress_box.line_chart <- renderPlotly({
  data <- progress_data()
  p <- plotly_default('任务性能', '迭代次数', '目标值')
  i <- 1

  for (job_id in names(data)) {
    y <- as.vector(data[[job_id]][['hist_f']])
    if (length(y) == 0) next()
    x <- seq(length(y))

    p <- add_trace(
      p, x = x, y = y, color = .colors[i %% 5], name = job_id,
      type = 'scatter', mode = 'lines+markers'
    )
    i <- i + 1
  }
  p
})

progress_data <- reactive({
  req(tell_lock$value == 0)
  isolate({
    job_list <- rownames(job_table())
    .json <- list(
      get_history = as.vector(job_list)
    )
  })
  r <- POST(address, body = .json, encode = 'json')
  content(r)
})

# AI Excelsior - A Bayesian Optimization Service

本接口是由`AI Excelsior`元学习引擎提供的远程异步自适应优化接口， 通过http请求帮助用户对其私有环境运行的机器学习模型、模拟器、 量化交易策略等实例进行参数/超参数的自动优化。在保证用户数据、 算法与实例私密性的同时，为用户提供高效的自适应优化服务。

我们为本接口提供两种服务模式：

* `RESTful`服务，其请求地址是: `http://207.246.97.250:7200`
* 图形用户界面：`http://207.246.97.250:3838` (请留意端口号的不同)

在如下的文档中，我们使用任务ID`CPbdA72Xv2outVk`作为例子展示`RESTful`接口，此ID应当被替换为用户在实际操作中所得到的任务ID。对于图形用户界面，用户只需阅读**创建搜索空间**一节来了解如何定制搜索任务。


## 创建搜索空间

向`http://207.246.97.250:7200`发出HTTP POST请求，其附带`JSON`数据字段, 例如:

```json
{
    "search_param" : {
        "continuous" : {          // 参数名称，用户可以自定义
            "type" : "r",         // 参数类型，共分为“r”实数型，“i”整数型，及“c”离散型
            "range" : [-5, 5],    // 该参数的取值范围
            "N" : 2,              // 类型、范围相同的参数个数
            "precison" : 2        // 该参数数值精度，其指示小数点后的位数
        },

        "ordinal" : {
            "type" : "i",
            "range" : [-100, 100],
            "N" : 1
        },

        "nominal" : {
            "type" : "c",
            "range" : ["OK", "A", "B", "C", "D", "E"],
            "N" : 1
        }
    },

    "bo_param" : {
        "n_job" : 3,              // 服务器上并行进程数
        "n_point" : 3,            // 每次迭代返回参数值个数
        "max_iter" : 20,          // 最大迭代次数
        "DoE_size" : 3,           // 初始(第一代)采样点个数，其一般与`n_point`相等
        "minimize" : true,        // 最大化目标值(false)，最小化目标值(true)
        "n_obj": 1                // 目标个数，当前版本仅支持单目标
    }
}
```

当新的优化任务工程创建后，服务器会通过如下的`JSON`回执返回任务ID

```json
{"job_id" : "CPbdA72Xv2outVk"}
```

在之后的请求中，用户将使用所返回的`job_id`.

## 请求一组新的解

发出`HTTP GET`请求:`http://207.246.97.250:7200?ask='null'&job_id=0r8FwcNmnXzRrPB`。
服务器会通过一个`JSON`数据字段来返回这组被请求的解，例如:

```json
{
    "job_id" : "CPbdA72Xv2outVk",
    "X" : [
        {    // 第一组参数
            'continuous_0' : 0.0,
            'continuous_1' : -3.33,
            ...
        },
        {   // 第二组参数
            'continuous_0' : 1.2,
            'continuous_1' : 3.33,
            ...
        }
    ]
}
```

## 将目标值提交至服务器

用户需执行在上一步中得到的这组解，并将运行后所得到的目标值加入到这个字段中，例如:

```json
{
    "job_id" : "CPbdA72Xv2outVk",   // 使用对应的任务 ID
    "X" : [
        ...                         // 上一步取回的解
    ],
    "y" : [10.0, 1.23, 13.33,...]   // 与这组参数对应的目标值
}
```

在这之后我们就可以向`http://207.246.97.250:7200`发出`HTTP POST`请求, 并附上这个`JSON`字段

## 终止一个任务

当用户不再想继续使用当前优化任务，或者需要创建新的优化任务时，该用户需要终止当前的优化任务，这可通过以下`HTTP GET`请求实现:
`http://207.246.97.250:7200?finalize='null'&job_id=CPbdA72Xv2outVk`
